local anim8 = require 'lib/anim8' -- calls the libary anim8 (animation libary)

Ingame = {}


--callbacks
function Ingame.enter()
	state = 5 -- sets state to 3
	
	IGAudio()
	font2 = love.graphics.newFont("assets/comic.ttf", 25)
	Ingame.start() -- starts function newGame
end

function Ingame.start()
	IGNewGame()
	IGCreateFireballs()
end

function Ingame.update(dt)
	IGUpdateBackground(dt)
	IGUpdatePlayer(dt)
	IGUpdateFireball(dt)
	IGUpdateCollision(dt)
	IGUpdateCountdown(dt)
	IGUpdateTimer(dt)
	IGUpdateScore(dt)
end

function Ingame.draw(dt)
	IGDrawBG()
	IGDrawScore(dt)
	IGDrawFireball()
	IGDrawCountdown()
	IGDrawPlayer()
end

function Ingame.death()
	IGOnDeath()
end

function Ingame.keypressed(key)
end

function Ingame.mousepressed(key)
end



--enter functions
function IGAudio()
end




--new game functions
function IGNewGame()
	time = 0
	currentscore = 0
	seconds = 0
	
	math.randomseed(os.time())
	
	player.hit = false
	player.y = screenHeight/2 - 50
	player.health = 3
	player.slowed = 0
	player.stunned = 0
end

function IGCreateFireballs()

	for i = 1,10 do 
		Fireball.x[i] = math.random(820, 1000)
		Fireball.speed[i] = math.random(100, 250)
		Fireball.random[i] = math.random(1, 4)
	end
end



--update functions
function IGUpdateCountdown(dt)
	if time < 3 then
		CountdownAnim:update(dt)
	end
end

function IGUpdateBackground(dt)
	Menu.x = Menu.x - (Menu.Speed * dt)
	Menu.x1 = Menu.x1 - (Menu.Speed * dt)

	if Menu.x < -1600 then 
		Menu.x = 810
	end
	if Menu.x1 < -800 then
		Menu.x1 = 1615
	end	
end

function IGUpdateTimer(dt)
	time = time + dt -- adds delta time to time to act as a timer
end

function IGUpdateScore(dt)
	if time > 3 then
		seconds = seconds + dt
		if seconds > 1.5 then
			seconds = 0
			currentscore = currentscore + 1
			love.audio.play(ScoreAudio)
		end
	end
end

function IGUpdateFireball(dt)
	if time > 3 then
		for i = 1, 10 do
			Fireball.x[i] = Fireball.x[i] - ((Fireball.speed[i] + (playerStats.exp * .025)) + currentscore) * (dt) -- makes fireballs move
				
			if Fireball.x[i] < -64 then -- if fireball x is left of the screen then it marks it
				Fireball.crossed[i] = true
			elseif Fireball.x[i] > -64 then -- if it isnt left of the screen it marks that it isnt
				Fireball.crossed[i] = false
			end
				
			if Fireball.crossed[i] == true then -- if fireball is marked left of screen then is respawns it
				Fireball.random[i] = math.random(1, 4)
				Fireball.x[i] = math.random(820, 1000)
				Fireball.speed[i] = math.random(100, 250)	
			end
		end
		FireballAnim:update(dt)
	end
end

function IGUpdateCollision(dt)
	local n = 64
	for i = 1, 10 do
		if Fireball.x[i] + 0 <= player.x + 20 and Fireball.x[i] + 0 >= player.x then
			if Fireball.y[i] + 15 <= player.y +76 and Fireball.y[i] + 15 >= player.y then
				if player.hit == false then
					player.hit = true
					IGOnHit(i)
				end
			end
		elseif Fireball.x[i] + 6 <= player.x + 20 and Fireball.x[i] + 6 >= player.x then
			if Fireball.y[i] + 7 <= player.y + 76 and Fireball.y[i] + 7 >= player.y then
				if player.hit == false then
					player.hit = true
					IGOnHit(i)
				end
			elseif Fireball.y[i] + 23 <= player.y + 76 and Fireball.y[i] + 23 >= player.y then
				if player.hit == false then
					player.hit = true
					IGOnHit(i)
				end
			end
		elseif Fireball.x[i] + 15 <= player.x + 20 and Fireball.x[i] + 15 >= player.x then
			if Fireball.y[i] + 7 <= player.y + 76 and Fireball.y[i] + 7 >= player.y then
				if player.hit == false then
					player.hit = true
					IGOnHit(i)
				end
			elseif Fireball.y[i] + 24 <= player.y + 76 and Fireball.y[i] + 24 >= player.y then
				if player.hit == false then
					player.hit = true
					IGOnHit(i)
				end
			end
		elseif Fireball.x[i] + 23 <= player.x + 20 and Fireball.x[i] + 23 >= player.x then
			if Fireball.y[i] + 9 <= player.y + 76 and Fireball.y[i] + 9 >= player.y then
				if player.hit == false then
					player.hit = true
					IGOnHit(i)
				end
			elseif Fireball.y[i] + 22 <= player.y + 76 and Fireball.y[i] + 22 >= player.y then
				if player.hit == false then
					player.hit = true
					IGOnHit(i)
				end
			end
		end
	end
end

function IGUpdatePlayer(dt)
	PlayerAnimation:update(dt)
	if time > 3 then
	
		if player.slowed > 0 then
			player.slowed = player.slowed - dt
		end
		if player.stunned > 0 then
			player.stunned = player.stunned - dt
		end
		--player stuff
		if love.keyboard.isDown("up") then -- if up arrow pressed then player moves up
			if player.slowed > 0 and player.stunned <= 0 then
				player.y = player.y - ((player.speed / 2) * dt)
			end
			if player.slowed <= 0 and player.stunned <= 0 then
				player.y = player.y - (player.speed * dt)
			end
			if player.y <= 50 then player.y = 50 end
		elseif love.keyboard.isDown("down") then -- else if down key is pressed player moves down
			if player.slowed > 0 and player.stunned <= 0  then
				player.y = player.y + ((player.speed / 2) * dt)
			end
			if player.slowed <= 0 and player.stunned <= 0 then
				player.y = player.y + (player.speed * dt)
			end
			if player.y >= 550 - 76 then player.y = 550 - 76 end
		end
	end
end



--draw functions
function IGDrawBG()
	love.graphics.setBackgroundColor( 0, 0, 0)
	love.graphics.setColor(0,16,0)
	love.graphics.rectangle("fill", 0, screenHeight - 48, screenWidth, 50) -- draws the ground
	love.graphics.setColor(255,255,255)
	love.graphics.draw(Menu.Background1, Menu.x, 0) -- draws menu
	love.graphics.draw(Menu.Background2, Menu.x1, 0) -- draws menu
	love.graphics.draw(Menu.Moon, 0, 0)
end

function IGDrawScore(dt)	
	love.graphics.setFont(font2)
	love.graphics.setColor(255, 255, 255)
	love.graphics.print("Score: "..currentscore, 10, screenHeight - 35)
	love.graphics.setColor(255, 0, 0)
	love.graphics.print("FPS: ".. love.timer.getFPS(), 630, screenHeight - 35)
	for i = 1, player.health do
		love.graphics.draw(player.Health, 290 + (i * 35), screenHeight - 35)
	end
	love.graphics.setColor(255, 255, 255)
	love.graphics.setFont(font)
end

function IGDrawFireball()
	if time > 3 then
		for i = 1,10 do
			for e = 1, 4 do
				if Fireball.random[i] == e then
					FireballAnim:draw(Fireball.animation[e], Fireball.x[i], Fireball.y[i]) -- draws Fireballs
				end
			end
		end
	end
end

function IGDrawCountdown()
	if time <= 3 then 
		CountdownAnim:draw(Countdown.Picture, screenWidth/2, screenHeight/2 - 50)
	end
end

function IGDrawPlayer()
	for i = 1,2 do
		for e = 1,6 do
			if playerStats.hair == i and playerStats.color == e then
				PlayerAnimation:draw(player[i][e], player.x, player.y)
			end
		end
	end
	if player.slowed > 0 then
		love.graphics.draw(player.Slowed,  player.x, player.y - 20)
	end
	if player.stunned > 0 then
		love.graphics.draw(player.Stunned,  player.x, player.y - 20)
	end
end



--hit functions
function IGOnHit(i)
	if player.hit then
		if Fireball.random[i] == 1 then
			love.audio.play(StunnedAudio)
			player.stunned = 3
			player.health = player.health - 1
		elseif Fireball.random[i] == 2 then
			love.audio.play(HitAudio)
			player.health = player.health - 1
		elseif Fireball.random[i] == 3 then
			love.audio.play(ExplosionAudio)
			player.health = player.health - 2
		elseif Fireball.random[i] == 4 then
			love.audio.play(SlowedAudio)
			player.slowed = 3
			player.health = player.health - 1
		end
		
		Fireball.x[i] = math.random(820, 1000)
		Fireball.speed[i] = math.random(100, 250)
		Fireball.random[i] = math.random(1, 4)
		player.hit = false
	end
	if player.health <= 0 then
		IGOnDeath()
	end
end

function IGOnDeath()
	GameOver.enter()
end