local anim8 = require 'lib/anim8' -- calls the libary anim8 (animation libary)
require 'player'
require 'Fireball'

function LoadResources()
	love.graphics.setDefaultFilter("nearest")

	--font stuff
	font = love.graphics.newFont("assets/comic.ttf", 45)
	font2 = love.graphics.newFont("assets/comic.ttf", 25)
	love.graphics.setFont(font)
	
	--audio
	SplashAudio = love.audio.newSource("assets/Audio/intro.mp3", static)
	HighscoreAudio = love.audio.newSource("assets/Audio/win.mp3", static)
	DeathAudio = love.audio.newSource("assets/Audio/lose.mp3", static)
	ScoreAudio = love.audio.newSource("assets/Audio/score.mp3", static)
	StunnedAudio = love.audio.newSource("assets/Audio/stunned.mp3", static)
	SlowedAudio = love.audio.newSource("assets/Audio/slowed.mp3", static)
	HitAudio = love.audio.newSource("assets/Audio/Hit.mp3", static)
	ExplosionAudio = love.audio.newSource("assets/Audio/Explosion.mp3", static)
	EvilLaugh = love.audio.newSource("assets/Audio/EvilLaugh.mp3", static)
	
	--instruction resource
	InstructionMenu = love.graphics.newImage("assets/Menus/Instructions.png")
	
	--menu stuff
	Menu = {}
	Menu.x = 10
	Menu.x1 = 1615
	Menu.Speed = 20
	Menu.Background1 = love.graphics.newImage("assets/Menus/Menu.png") -- sets first menu
	Menu.Background2 = love.graphics.newImage("assets/Menus/Menu1.png") -- sets first menu
	Menu.Screen = love.graphics.newImage("assets/Menus/MenuScreen.png") -- sets first menu
	Menu.Moon = love.graphics.newImage("assets/Menus/Moon.png") -- sets first menu

	--splash stuff	
	Splash.pic = love.graphics.newImage("assets/Menus/Splash.png") -- setting the splash
	local splash = anim8.newGrid(800, 600, Splash.pic:getWidth(), Splash.pic:getHeight())--setting image grid up.
	splashAnim = anim8.newAnimation(splash(1,1, 2,1, 3,1, 1,2, 2,2, 3,2, 1,3, 2,3, 3,3, 1,4, 2,4, 3,4, 1,5, 2,5, 3,5, 1,6, 2,6, 3,6, 1,7, 2,7,
	3,7, 1,8, 2,8, 3,8, 1,9, 2,9, 3,9, 1,10, 1,10), .24139) -- sets the animation (grid(frames), duration)
	
	--character state stuff
	CharacterMenu1 = love.graphics.newImage("assets/Menus/CharacterMain.png") -- sets character picture
	CharacterMenu2 = love.graphics.newImage("assets/Menus/CharacterMain1.png") -- sets character picture
	
	--player stuff
	local playerGrid = anim8.newGrid(32, 76, 32, 456)--setting image grid up.
	PlayerAnimation = anim8.newAnimation(playerGrid(1,'1-6'), .2) -- sets the animation (grid(frames), duration)
	
	
	player.Health = love.graphics.newImage("assets/Player/HealthImg.png")
	player.Slowed = love.graphics.newImage("assets/Player/SlowedImg.png")
	player.Stunned = love.graphics.newImage("assets/Player/StunnedImg.png")
	
	--Male
	for i = 1,2 do
		player[i] = {}
		for e = 1,6 do
			player[i][e] = love.graphics.newImage("assets/Player/1"..i..""..e..".png")
		end
	end

	--fireball animation
	Fireball.animation = {}
	for e = 1,4 do
		Fireball.animation[e] = love.graphics.newImage("assets/FireballAnim"..e..".png") -- aetting the animation1 picture.
	end
	
	local g2 = anim8.newGrid(32, 32, Fireball.animation[1]:getWidth(), Fireball.animation[1]:getHeight())--setting image grid up.
	FireballAnim = anim8.newAnimation(g2(1, '1-6'), .1) -- sets the animation (grid(frames), duration)
	
	--ingame countdow
	Countdown = {}
	Countdown.Picture = love.graphics.newImage("assets/Menus/Countdown.png") -- setting the countdownpicture.
	local CountdownGrid = anim8.newGrid(57, 88, Countdown.Picture:getWidth(), Countdown.Picture:getHeight())--setting countdowngrid up.
	CountdownAnim = anim8.newAnimation(CountdownGrid(1,'1-3'), 1) -- sets the animation (grid(frames), duration)
	
	--scoreboard
	
	--gameover resources
	GameOverMenu1 = love.graphics.newImage("assets/Menus/GameOver1.png")
	GameOverMenu2 = love.graphics.newImage("assets/Menus/GameOver2.png")
end
