local anim8 = require 'lib/anim8' -- calls the libary anim8 (animation libary)

Splash = {}


--callbacks
function Splash.enter()
	state = 1
	
	SPSetTime()
end

function Splash.update(dt)
	SPUpdateTime(dt)
	SPUpdateSplash(dt)
	SPTimeChecker(dt)
	SPAudio()
end

function Splash.draw(dt)
	SPDrawSplash()
end

function Splash.mousepressed(x, y, button)
	SPSkip(x,y,button)
end













--enter functions
function SPSetTime()
	time = 0 -- setting time to 0
end



--update functions
function SPUpdateTime(dt)
	time = time + dt
end

function SPUpdateSplash(dt)
	if time > 1 then
		splashAnim:update(dt)
	end
end

function SPTimeChecker(dt)
	if time > 8 then
		if playerStats.charselect == true then
			MainMenu.enter()
		end
		if playerStats.charselect == false then
			Character.begin()
		end
	end
end



--draw functions
function SPDrawSplash()
	if time > 1 then
		splashAnim:draw(Splash.pic, 0, 0)
	end
end


--audio function
function SPAudio()
	if time > 1 then
		love.audio.play(SplashAudio)
	end
end


--mouse functions
function SPSkip(x,y,button)
	if button == "l" then
		love.audio.stop(SplashAudio)
		if playerStats.charselect == true then
			MainMenu.enter()
		end
		if playerStats.charselect == false then
			Character.begin()
		end
	end
end
